# Juniper SRX connector
- - - -
## Table of contents
[Requirements](#requirements)<br>
[Connector description](#connector-description)<br>
[Example of log file](#example-of-log-file)<br>
[SRX configuration](#srx-configuration)<br>
[Syslog configuration](#syslog-configuration)<br>
[Example of warden configuration](#example-of-warden-configuration)<br>
[IDEA format sent to warden](#idea-format-sent-to-warden)<br>
[Generator instructions](#generator-instructions)<br>
- - - -
## Requirements
1. Platform: 
    * Python 2.7+
2. Python packages: 
    *warden_client 3.0+
3. Properly configured Syslog Server and Juniper SRX Server (all can be simulated by provided data [generator](#generator-instructions) for testing)

Also, the connector should already be registered as sending client on a Warden server (Protective node). This means you should know/have:

* URL of the Warden server
* Client name
* Client certificate and corresponding private key (cert.pem, key.pem)
* (Server certificate (e.g. server.crt.pem), if the Warden server uses self-signed certificate)

You can use warden_client available in connector repository. Alternatively, install warden_client library from repository. Download the Warden repository from GitLab (e.g. to your home) and copy the warden_client package to the site-packages folder of your Python installation. The exact destination path depends on the OS type and Python version used.
```
git clone git@gitlab.com:protective-h2020-eu/ti-s/Warden/Warden.git
sudo cp Warden/warden_client/warden_client.py /usr/lib64/python2.7/site-packages/
```

## Connector description
srx_connector.py is a **python script**, **reading logfile** generated by **Syslog Server** (/var/log/srx.log), **parsing it to IDEA** format and sending to warden **using warden-client**. It is a script, so it should be run for example once a week.
To know, where connector ended up reading log file, last_run.log is created where this information is stored (last processed log time). It starts parsing from the log after this date. 
* if last_run.log does not exist - all logs are parsed. 
* if last_run.log contains date earlier than first log in logfile - all logs are parsed.
* if last_run.log contains date later than last log in logfile - no logs are parsed.
* else logs are parsed from the date after this in last_run.log (if there is not such log, no logs are parsed)

SRX logs have to be sent by Syslog Server to file (/var/log/srx.log). 
Connector should be run on machine, where Syslog Server or Log Generator put logs.

**Note:** to change the location, where SRX connector tries to find logs, please change field *logfile* in srx_connector.py script.
## Example of log file:
```
Nov 15 12:17:32 FIREWALL_1 RT_IDP: IDP_ATTACK_LOG_EVENT_LS: Lsys LSYS-SITE1-net: IDP: At 1510748253, SIG Attack log <2001:db8::a8cc/53026->2a00:1450:401b:800:0:0:0:200e/443> for TCP protocol and service SERVICE_IDP application HTTP2 by rule 3 of rulebase IPS in policy Client-Protection. attack: id=19522, repeat=0, action=NONE, threat-severity=HIGH, name=SSL:OPENSSL-MEM-DOS, NAT <0.0.0.0:0->0.0.0.0:0>, time-elapsed=0, inbytes=0, outbytes=0, inpackets=0, outpackets=0, intf:VLAN2:reth999.9090->INTERNET-MAIN:reth888.8080, packet-log-id: 0, alert=no, username=N/A, roles=N/A and misc-message -
Nov 15 12:18:19 FIREWALL_1 RT_IDP: IDP_ATTACK_LOG_EVENT_LS: Lsys LSYS-SITE1-net: IDP: At 1510748300, SIG Attack log <2001:db8::a8cc/53231->2a00:1450:401b:800:0:0:0:200e/443> for TCP protocol and service SERVICE_IDP application GOOGLE-PLUS-SSL by rule 3 of rulebase IPS in policy Client-Protection. attack: id=19522, repeat=0, action=NONE, threat-severity=HIGH, name=SSL:OPENSSL-MEM-DOS, NAT <0.0.0.0:0->0.0.0.0:0>, time-elapsed=0, inbytes=0, outbytes=0, inpackets=0, outpackets=0, intf:VLAN2:reth999.9090->INTERNET-MAIN:reth888.8080, packet-log-id: 0, alert=no, username=N/A, roles=N/A and misc-message -
```
/var/log/srx.log should be updated by Syslog Server. 

## SRX configuration

Note: all off the logs are sent to SysLog in plain text - security should be provided.

Address-book configuration for LogServer:
```
SRX-node0# show security address-book
   global {
       address LogServer_Protective <LogServerAddress/Mask>;
   }
```
LogServer interface configuration:
```
SRX-node0# show interfaces
   <NetworkInterfaceId [e.g. ge-1/0/3]> {
       description "Protective-Logserver";
       unit 0 {
           family inet {
               address <SourceAddress/Mask>;
           }
       }
   }
   ```
Policy configuration:
```
SRX-node0# show security policies global
   policy SendLogsToLogserver {
       match {
           source-address any;
           destination-address [ LogServer_Protective ];
           application junos-syslog;
           from-zone any;
           to-zone LogServer;
       }
       then {
           permit {
               application-services {
                   idp;
               }
           }
       }
   }
   ```
Remote login configuration (idp in the following example):
```
SRX-node0# show security log
    source-address <SourceAddress>;
    stream securitylog {
        format syslog;
        category idp;
        host {
            <LogServerAddress>;
        }
    }
```



## Syslog configuration
.# cat /etc/rsyslog.conf | grep RT_IDP (all our srx logs contain "RT_IDP")
```
 *.info;mail.none;authpriv.none;cron.none, contains, "RT_IDP"
 /var/log/srx.log
```
.# cat /etc/logrotate.conf
```
 /var/log/messages.log
 {
         rotate 6
         monthly
         missingok
         notifempty
         delaycompress
         compress
         postrotate
         invoke-rc.d rsyslog rotate > /dev/null
         endscript
  }

 /var/log/srx.log
 {
         rotate 6
         monthly
         missingok
         notifempty
         delaycompress
         compress
         postrotate
         invoke-rc.d rsyslog rotate > /dev/null
         endscript
  }
```
Configure cron to run script every 5 min:
```
*/5 *   * * *   root    /usr/bin/python /opt/warden3-srx/srx_connector.py &>> /var/log/srx_connector.log
```
## Example of warden configuration
To send data properly into Warden and Mentat, proper configuration of warden-client is needed. To do so, warden_client-srx.cfg file needs to be modified.  Replace WARDEN_SERVER_URL, WARDEN_CLIENT_NAME and paths to certificates with appropriate values:
```
{
    "warden": "warden_client.cfg",
    "name": "WARDEN_CLIENT_NAME",
 
    # secret to authenticate client, if 'secret' is non empty, is used instead of value in client's configuration - useful while using more sensors with single client's configuration
    #"secret" = "srx_secret"
    # values: no (default)| yes (anonymize to 'target_net')| omit (completely omit target field)
    "anonymised": "no",
    #"target_net": "10.10.1.1/16",
    # aggregation window, e.g. 5 for events in the last 5 minutes
    "awin": 5
}
```
What's more, warden_client.cfg should be edited (name from warden_client-srx.cfg and warden_client.cfg should be the same):
```
{
    "url": "WARDEN_SERVER_URL",
    "certfile": "/warden_client_keys/cert.pem",
    "keyfile": "/warden_client_keys/key.pem",
    "cafile": "/warden_client_keys/ca.pem",
    "timeout": 60,
    "get_events_limit": 1000,
    "errlog": {"level": "debug"},
    "filelog": {"level": "debug", "file": "/var/log/warden_filer.log"},
    "name": "WARDEN_CLIENT_NAME"
}
```

## IDEA format sent to warden
```json
{
    "Format": "IDEA0", 
    "ID": "bbb5ea52-847e-43a0-8328-6a79cb6c3290", 
    "DetectTime": "2017-09-13 16:04:20", 
    "CreateTime": "2017-10-05 10:06:02", 
    "Category": [
        "severity.high"
    ], 
    "Description": "for TCP protocol and service SERVICE_IDP application HTTP2 by rule 3 of rulebase IPS in policy Client-Protection.", 
    "ByteCount": [
        3467
    ], 
    "PacketCount": [
        555
    ], 
    "Source": [
        {
            "IP6": [
                "1111:222:0:1111:a333:eeaa:r3r3:a12"
            ], 
            "Router": [
                "Bob-Something-NAT", 
                "Something.9999"
            ], 
            "Proto": [
                "TCP"
            ], 
            "Port": [
                123456
            ]
        }
    ], 
    "Target": [
        {
            "IP6": [
                "1a11:2222:333d:111:0:0:0:111e"
            ], 
            "Router": [
                "SRX-MAIN", 
                "Something2.999"
            ], 
            "Proto": [
                "TCP"
            ], 
            "Port": [
                443
            ]
        }
    ], 
    "Node": [
        {
            "Name": "pl.psnc.SRX-BST-A", 
            "SW": [
                "Something_JPL"
            ], 
            "Type": [
                "Juniper SRX"
            ]
        }
    ]
}
```
## Generator instructions
To produce some logs for testing, special generator has been implemented. It can continuously generate logs to specified file, simulating properly configured Syslog Server and Juniper SRX Server.
### Generator configuration
To run generator, **generator.cfg** file needs to be configured.
```
output - output dir
min_sleep - minimum break between logs (in seconds)
max_sleep - maximum break between logs (in seconds)(break is selected randomly)
real_sleep - (true/false) if false, breaks between logs are only simulated (break time is added to previous log time), it's generated at once, if true - break take place, generator works in real time
max_logs - maximum amount of logs to generate
regular - json with information about regular logs (srcs, dsts, ports...)
anomaly - json with information about anomaly logs (srcs, dsts, ports...)
```
All the important fields (interpreted by connector) are found in the first column (in both regular and anomaly json). The values of the rest can be filled, but in current version of connector, they won't appear in IDEA log. All values should be inserted in the right list, from which generator will draw random value.

Anomaly log appears with frequency 1/100.

**Note**: to change the location, where SRX connector tries to find logs, please change field *logfile* in srx_connector.py script to match with the output dir of generator.
### Running generator
To run generator, execute bash command:
```bash
python srx_generator.py
```
Make sure, that output directory exists and generator.cfg is placed in the same directory as srx_generator.py.

**Note:** for testing, generator and connector should be run on the same machine and output of the generator should be an input of the connector. Output of the generator can be set in generator.cfg, the input of connector script can be changed directly in srx_connector.py script in field *logfile*.